import * as Cheerio from "cheerio";
import * as O from "fp-ts/Option";
export declare const fromDocument: (markdown: string) => Endpoint[];
export declare const isEndpointSection: (section: string[]) => boolean;
export declare const fromSection: (section: string[]) => {
    route: string;
    description: O.Option<string>;
    method: string;
    url: string;
    params: O.Option<{
        identifier: string;
        fields: {
            name: string;
            optional: boolean;
            type: {
                identifier: string;
                nullable: boolean;
                array: boolean;
            };
            description: string;
        }[];
    }>;
    response: O.Option<{
        ref: O.Option<string>;
        array: boolean;
    }>;
};
export declare type Endpoint = ReturnType<typeof fromSection>;
export declare const identifier: (heading: string) => string;
export declare const url: (raw: string) => string;
export declare const parseResponse: (markdown: string) => {
    ref: O.Option<string>;
    array: boolean;
};
export declare const params: ($: Cheerio.CheerioAPI, route: string) => O.Option<{
    identifier: string;
    fields: {
        name: string;
        optional: boolean;
        type: {
            identifier: string;
            nullable: boolean;
            array: boolean;
        };
        description: string;
    }[];
}>;
export declare const description: ($: Cheerio.CheerioAPI) => O.Option<string>;
