import * as Cheerio from "cheerio";
import * as O from "fp-ts/Option";
export declare const excludeR: RegExp;
export declare const fromDocument: ($: Cheerio.CheerioAPI, exclude?: RegExp, include?: RegExp) => Structure[];
export declare const fromHeader: ($: Cheerio.CheerioAPI) => ($h6: Cheerio.Cheerio<Cheerio.Element>, $table: Cheerio.Cheerio<Cheerio.Element>) => {
    identifier: string;
    fields: {
        name: string;
        optional: boolean;
        type: {
            identifier: string;
            nullable: boolean;
            array: boolean;
        };
        description: string;
    }[];
};
export declare type Structure = ReturnType<ReturnType<typeof fromHeader>>;
export declare const identifier: (heading: string) => string;
export declare const fields: ($: Cheerio.CheerioAPI) => ($table: Cheerio.Cheerio<Cheerio.Element>) => {
    name: string;
    optional: boolean;
    type: {
        identifier: string;
        nullable: boolean;
        array: boolean;
    };
    description: string;
}[];
export declare const field: ($name: Cheerio.Cheerio<Cheerio.Element>, $type: Cheerio.Cheerio<Cheerio.Element>, $description: Cheerio.Cheerio<Cheerio.Element>) => {
    name: string;
    optional: boolean;
    type: {
        identifier: string;
        nullable: boolean;
        array: boolean;
    };
    description: string;
};
export declare const type: ($type: Cheerio.Cheerio<Cheerio.Element>, $description: Cheerio.Cheerio<Cheerio.Element>) => {
    identifier: string;
    nullable: boolean;
    array: boolean;
};
export declare const referenceFromLinks: ($links: Cheerio.Cheerio<Cheerio.Element>, includeStructures?: boolean) => O.Option<string>;
export declare const referenceFromLink: ($link: Cheerio.Cheerio<Cheerio.Element>, includeStructures?: boolean) => O.Option<string>;
export declare const identifierOrReference: (identifier: string, relation: O.Option<string>, $description: Cheerio.Cheerio<Cheerio.Element>) => string;
