"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.identifierOrReference = exports.referenceFromLink = exports.referenceFromLinks = exports.type = exports.field = exports.fields = exports.identifier = exports.fromHeader = exports.fromDocument = exports.excludeR = void 0;
const F = __importStar(require("fp-ts/function"));
const O = __importStar(require("fp-ts/Option"));
const R = __importStar(require("remeda"));
const Common = __importStar(require("./common"));
const Enums = __importStar(require("./enums"));
const isStructureTable = ($) => ($table) => {
    const $th = $table.find("th");
    const headers = $th.map((_, th) => $(th).text().trim()).toArray();
    const field = headers.some((text) => /field|name/i.test(text));
    const type = headers.some((text) => /type|value/i.test(text));
    const description = headers.some((text) => /description/i.test(text));
    return field && type && description;
};
exports.excludeR = /(%|example|params|json|type|change key)/i;
const headerSelectors = ["h2", "h6", "#client-status-object"];
const fromDocument = ($, exclude = exports.excludeR, include = /.*/) => $(headerSelectors.join(", "))
    .toArray()
    .map((h6) => [
    $(h6),
    Common.table($(h6)),
])
    .filter(([_$h6, $table]) => isStructureTable($)($table))
    .filter(([$h6, _]) => !exclude.test($h6.text()))
    .filter(([$h6, _]) => include.test($h6.text()))
    .map(([$h6, $table]) => exports.fromHeader($)($h6, $table));
exports.fromDocument = fromDocument;
const fromHeader = ($) => ($h6, $table) => ({
    identifier: exports.identifier($h6.text()),
    fields: exports.fields($)($table),
});
exports.fromHeader = fromHeader;
const identifier = (heading) => F.pipe(heading
    .replace(/(\s+|-)fields/i, "")
    .replace(/(\s+|-)object/i, "")
    .replace(/(\s+|-)structure$/i, "")
    .replace(/optional/i, "")
    .trim(), Common.typeify, Common.maybeRename);
exports.identifier = identifier;
const fields = ($) => ($table) => {
    const headerCount = $table.find("th").length;
    return F.pipe($table
        .find("td")
        .map((_, td) => $(td))
        .toArray(), R.chunk(headerCount), R.map((fields) => exports.field(fields[0], fields[1], fields[2])));
};
exports.fields = fields;
const field = ($name, $type, $description) => {
    const name = $name.text().replace(/\*/g, "").trim();
    const identifier = name.replace(/\?/g, "");
    const optional = /\?$/.test(name);
    return {
        name: identifier,
        optional,
        type: exports.type($type, $description),
        description: $description.text(),
    };
};
exports.field = field;
const type = ($type, $description) => {
    const text = $type.text();
    const nullable = text.startsWith("?");
    const array = /list|array/i.test(text);
    const rawIdentifier = sanitizeIdentifier(text);
    const relation = exports.referenceFromLinks($type.find("a"));
    return {
        identifier: exports.identifierOrReference(rawIdentifier, relation, $description),
        nullable,
        array,
    };
};
exports.type = type;
const sanitizeIdentifier = (text) => F.pipe(O.some(text), 
// Snowflake?
O.filter((text) => /\b(snowflake|object id)/.test(text)), O.map(() => "snowflake"), 
// String?
O.alt(() => F.pipe(O.fromNullable(text.match(/\bstrings?\b/)), O.map(() => "string"))), 
// Timestamp?
O.alt(() => F.pipe(O.fromNullable(text.match(/timestamp\b/)), O.map(() => "timestamp"))), 
// Normalize ints
O.alt(() => F.pipe(O.fromNullable(text.match(/\bint/)), O.map(() => "integer"))), 
// Boolean
O.alt(() => F.pipe(O.fromNullable(text.match(/\bboolean\b/)), O.map(() => "boolean"))), O.alt(() => F.pipe(O.fromNullable(text.match(/array|list/)), O.map(() => "array"))), O.alt(() => F.pipe(O.fromNullable(text.match(/dict/)), O.map(() => "dict"))), O.alt(() => F.pipe(O.fromNullable(text.match(/null/)), O.map(() => "null"))), O.alt(() => F.pipe(O.fromNullable(text.match(/json of id: (\w+)/i)), O.map((type) => `${type[1]}Map`))), 
// Mixed
O.alt(() => F.pipe(O.fromNullable(text.match(/mixed|\bOptionType\b/)), O.map(() => "mixed"))), 
// Normal identifier
O.getOrElse(() => F.pipe(text.replace(/[^A-z]/g, ""), Common.typeify, Common.maybeRename)));
const referenceFromLinks = ($links, includeStructures = true) => F.pipe(O.some($links), 
// Get the first link's href
O.filter(($links) => $links.length > 0), O.map(($links) => $links.first()), O.chain(($link) => exports.referenceFromLink($link, includeStructures)));
exports.referenceFromLinks = referenceFromLinks;
const referenceFromLink = ($link, includeStructures = true) => F.pipe(O.some($link), O.chainNullableK(($link) => $link.attr("href")), O.filter((href) => !/wikipedia/.test(href)), O.chainNullableK(F.flow((href) => href.split("/"), R.last)), O.chain((ref) => F.pipe(
// Structures
O.some(ref), O.filter(() => includeStructures), O.filter((ref) => !exports.excludeR.test(ref)), O.map((ref) => ref.replace(/^.*-object-/, "")), 
// Misc clean up
O.map((ref) => ref.replace(/^data-models-/, "")), O.map((ref) => ref.replace(/identify-identify/, "identify")), O.map(exports.identifier), 
// Enum
O.alt(() => F.pipe(O.some(ref), O.filter((ref) => Enums.enumSuffixR.test(ref)), O.map((ref) => ref.replace(/^.*-object-/, "")), O.map((ref) => ref.replace(/^data-models-/, "")), O.map((ref) => ref.replace(/^update-status-/, "")), O.map(Enums.identifier))), 
// Objects
O.alt(() => F.pipe(O.some(ref), O.filter(() => includeStructures), O.filter((ref) => /-object$/.test(ref)), O.map((ref) => ref.replace(/^data-models-/, "")), O.map((ref) => ref.replace(/-object$/, "")), O.map(Common.typeify), O.map(Common.maybeRename))), 
// Everything else
O.alt(() => F.pipe(O.some(ref), O.filter(() => includeStructures), O.map(Common.typeify), O.map(Common.maybeRename))))));
exports.referenceFromLink = referenceFromLink;
const identifierOrReference = (identifier, relation, $description) => F.pipe(
// Only use relation if it isn't a snowflake or mixed
O.some(identifier), O.filter((id) => !["snowflake", "mixed"].includes(id)), O.chain(() => relation), 
// Maybe use reference for arrays or objects
O.alt(() => F.pipe(O.some(identifier), O.filter((id) => /array|mixed/.test(id)), O.chain(() => exports.referenceFromLinks($description.find("a"))))), 
// Maybe use reference for enumerable types
O.alt(() => F.pipe(O.some(identifier), O.filter((id) => ["string", "integer"].includes(id)), O.chain(() => exports.referenceFromLinks($description.find("a"), false)))), O.getOrElse(() => identifier.replace(/arrayof/, "")));
exports.identifierOrReference = identifierOrReference;
